diff --git a/orocos_kdl/tests/framestest.cpp b/orocos_kdl/tests/framestest.cpp
index fd132db..793fe98 100644
--- a/orocos_kdl/tests/framestest.cpp
+++ b/orocos_kdl/tests/framestest.cpp
@@ -1,3 +1,4 @@
+#define _USE_MATH_DEFINES  // For MSVC
 #include <math.h>
 #include "framestest.hpp"
 #include <frames_io.hpp>
@@ -352,17 +353,17 @@ void FramesTest::TestRotation() {
 	TestRangeArbitraryRotation("[0,0,1]", Vector(0,0,1), Vector(0,0,1));
 	TestRangeArbitraryRotation("[0,0,-1]", Vector(0,0,-1), Vector(0,0,-1));
 	// X,Y axes
-	TestRangeArbitraryRotation("[1,1,0]", Vector(1,1,0), Vector(1,1,0)/sqrt(2.0));
-	TestRangeArbitraryRotation("[-1,-1,0]", Vector(-1,-1,0), Vector(-1,-1,0)/sqrt(2.0));
+	TestRangeArbitraryRotation("[1,1,0]", Vector(1,1,0), Vector(1,1,0)/::sqrt(2.0));
+	TestRangeArbitraryRotation("[-1,-1,0]", Vector(-1,-1,0), Vector(-1,-1,0)/::sqrt(2.0));
 	// X,Z axes
-	TestRangeArbitraryRotation("[1,0,1]", Vector(1,0,1), Vector(1,0,1)/sqrt(2.0));
-	TestRangeArbitraryRotation("[-1,0,-1]", Vector(-1,0,-1), Vector(-1,0,-1)/sqrt(2.0));
+	TestRangeArbitraryRotation("[1,0,1]", Vector(1,0,1), Vector(1,0,1)/::sqrt(2.0));
+	TestRangeArbitraryRotation("[-1,0,-1]", Vector(-1,0,-1), Vector(-1,0,-1)/::sqrt(2.0));
 	// Y,Z axes
-	TestRangeArbitraryRotation("[0,1,1]", Vector(0,1,1), Vector(0,1,1)/sqrt(2.0));
-	TestRangeArbitraryRotation("[0,-1,-1]", Vector(0,-1,-1), Vector(0,-1,-1)/sqrt(2.0));
+	TestRangeArbitraryRotation("[0,1,1]", Vector(0,1,1), Vector(0,1,1)/::sqrt(2.0));
+	TestRangeArbitraryRotation("[0,-1,-1]", Vector(0,-1,-1), Vector(0,-1,-1)/::sqrt(2.0));
 	// X,Y,Z axes
-	TestRangeArbitraryRotation("[1,1,1]", Vector(1,1,1), Vector(1,1,1)/sqrt(3.0));
-	TestRangeArbitraryRotation("[-1,-1,-1]", Vector(-1,-1,-1), Vector(-1,-1,-1)/sqrt(3.0));
+	TestRangeArbitraryRotation("[1,1,1]", Vector(1,1,1), Vector(1,1,1)/::sqrt(3.0));
+	TestRangeArbitraryRotation("[-1,-1,-1]", Vector(-1,-1,-1), Vector(-1,-1,-1)/::sqrt(3.0));
 
 	// these change ... some of the -180 are the same as the +180, and some
 	// results are the opposite sign.
@@ -377,33 +378,33 @@ void FramesTest::TestRotation() {
 	// same as +180
 	TestOneRotation("rot([0,0,-1],180)", KDL::Rotation::Rot(KDL::Vector(0,0,-1),180*deg2rad), 180*deg2rad, Vector(0,0,1));
 
-	TestOneRotation("rot([1,0,1],180)", KDL::Rotation::Rot(KDL::Vector(1,0,1),180*deg2rad), 180*deg2rad, Vector(1,0,1)/sqrt(2.0));
+	TestOneRotation("rot([1,0,1],180)", KDL::Rotation::Rot(KDL::Vector(1,0,1),180*deg2rad), 180*deg2rad, Vector(1,0,1)/::sqrt(2.0));
 	// same as +180
-	TestOneRotation("rot([1,0,1],-180)", KDL::Rotation::Rot(KDL::Vector(1,0,1),-180*deg2rad), 180*deg2rad, Vector(1,0,1)/sqrt(2.0));
-	TestOneRotation("rot([-1,0,-1],180)", KDL::Rotation::Rot(KDL::Vector(-1,0,-1),180*deg2rad), 180*deg2rad, Vector(1,0,1)/sqrt(2.0));
+	TestOneRotation("rot([1,0,1],-180)", KDL::Rotation::Rot(KDL::Vector(1,0,1),-180*deg2rad), 180*deg2rad, Vector(1,0,1)/::sqrt(2.0));
+	TestOneRotation("rot([-1,0,-1],180)", KDL::Rotation::Rot(KDL::Vector(-1,0,-1),180*deg2rad), 180*deg2rad, Vector(1,0,1)/::sqrt(2.0));
 	// same as +180
-	TestOneRotation("rot([-1,0,-1],-180)", KDL::Rotation::Rot(KDL::Vector(-1,0,-1),-180*deg2rad), 180*deg2rad, Vector(1,0,1)/sqrt(2.0));
+	TestOneRotation("rot([-1,0,-1],-180)", KDL::Rotation::Rot(KDL::Vector(-1,0,-1),-180*deg2rad), 180*deg2rad, Vector(1,0,1)/::sqrt(2.0));
 
-	TestOneRotation("rot([1,1,0],180)", KDL::Rotation::Rot(KDL::Vector(1,1,0),180*deg2rad), 180*deg2rad, Vector(1,1,0)/sqrt(2.0));
+	TestOneRotation("rot([1,1,0],180)", KDL::Rotation::Rot(KDL::Vector(1,1,0),180*deg2rad), 180*deg2rad, Vector(1,1,0)/::sqrt(2.0));
 	// opposite of +180
-	TestOneRotation("rot([1,1,0],-180)", KDL::Rotation::Rot(KDL::Vector(1,1,0),-180*deg2rad), 180*deg2rad, -Vector(1,1,0)/sqrt(2.0));
-	TestOneRotation("rot([-1,-1,0],180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,0),180*deg2rad), 180*deg2rad, -Vector(1,1,0)/sqrt(2.0));
+	TestOneRotation("rot([1,1,0],-180)", KDL::Rotation::Rot(KDL::Vector(1,1,0),-180*deg2rad), 180*deg2rad, -Vector(1,1,0)/::sqrt(2.0));
+	TestOneRotation("rot([-1,-1,0],180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,0),180*deg2rad), 180*deg2rad, -Vector(1,1,0)/::sqrt(2.0));
 	// opposite of +180
-	TestOneRotation("rot([-1,-1,0],-180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,0),-180*deg2rad), 180*deg2rad, Vector(1,1,0)/sqrt(2.0));
+	TestOneRotation("rot([-1,-1,0],-180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,0),-180*deg2rad), 180*deg2rad, Vector(1,1,0)/::sqrt(2.0));
 
-	TestOneRotation("rot([0,1,1],180)", KDL::Rotation::Rot(KDL::Vector(0,1,1),180*deg2rad), 180*deg2rad, Vector(0,1,1)/sqrt(2.0));
+	TestOneRotation("rot([0,1,1],180)", KDL::Rotation::Rot(KDL::Vector(0,1,1),180*deg2rad), 180*deg2rad, Vector(0,1,1)/::sqrt(2.0));
 	// same as +180
-	TestOneRotation("rot([0,1,1],-180)", KDL::Rotation::Rot(KDL::Vector(0,1,1),-180*deg2rad), 180*deg2rad, Vector(0,1,1)/sqrt(2.0));
-	TestOneRotation("rot([0,-1,-1],180)", KDL::Rotation::Rot(KDL::Vector(0,-1,-1),180*deg2rad), 180*deg2rad, Vector(0,1,1)/sqrt(2.0));
+	TestOneRotation("rot([0,1,1],-180)", KDL::Rotation::Rot(KDL::Vector(0,1,1),-180*deg2rad), 180*deg2rad, Vector(0,1,1)/::sqrt(2.0));
+	TestOneRotation("rot([0,-1,-1],180)", KDL::Rotation::Rot(KDL::Vector(0,-1,-1),180*deg2rad), 180*deg2rad, Vector(0,1,1)/::sqrt(2.0));
 	// same as +180
-	TestOneRotation("rot([0,-1,-1],-180)", KDL::Rotation::Rot(KDL::Vector(0,-1,-1),-180*deg2rad), 180*deg2rad, Vector(0,1,1)/sqrt(2.0));
+	TestOneRotation("rot([0,-1,-1],-180)", KDL::Rotation::Rot(KDL::Vector(0,-1,-1),-180*deg2rad), 180*deg2rad, Vector(0,1,1)/::sqrt(2.0));
 
-	TestOneRotation("rot([1,1,1],180)", KDL::Rotation::Rot(KDL::Vector(1,1,1),180*deg2rad), 180*deg2rad, Vector(1,1,1)/sqrt(3.0));
+	TestOneRotation("rot([1,1,1],180)", KDL::Rotation::Rot(KDL::Vector(1,1,1),180*deg2rad), 180*deg2rad, Vector(1,1,1)/::sqrt(3.0));
 	// same as +180
-	TestOneRotation("rot([1,1,1],-180)", KDL::Rotation::Rot(KDL::Vector(1,1,1),-180*deg2rad), 180*deg2rad, Vector(1,1,1)/sqrt(3.0));
-	TestOneRotation("rot([-1,-1,-1],180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,-1),180*deg2rad), 180*deg2rad, Vector(1,1,1)/sqrt(3.0));
+	TestOneRotation("rot([1,1,1],-180)", KDL::Rotation::Rot(KDL::Vector(1,1,1),-180*deg2rad), 180*deg2rad, Vector(1,1,1)/::sqrt(3.0));
+	TestOneRotation("rot([-1,-1,-1],180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,-1),180*deg2rad), 180*deg2rad, Vector(1,1,1)/::sqrt(3.0));
 	// same as +180
-	TestOneRotation("rot([-1,-1,-1],-180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,-1),-180*deg2rad), 180*deg2rad, Vector(1,1,1)/sqrt(3.0));
+	TestOneRotation("rot([-1,-1,-1],-180)", KDL::Rotation::Rot(KDL::Vector(-1,-1,-1),-180*deg2rad), 180*deg2rad, Vector(1,1,1)/::sqrt(3.0));
 }
 
 void FramesTest::TestQuaternion() {
@@ -420,15 +421,15 @@ void FramesTest::TestQuaternion() {
     // 45 deg rotation in X
     R = Rotation::EulerZYX(0,0,45*deg2rad);
     R.GetQuaternion(x,y,z,w);
-	CPPUNIT_ASSERT_DOUBLES_EQUAL(x, sin((45*deg2rad)/2), epsilon);
+	CPPUNIT_ASSERT_DOUBLES_EQUAL(x, ::sin((45*deg2rad)/2), epsilon);
 	CPPUNIT_ASSERT_DOUBLES_EQUAL(y, 0, epsilon);
 	CPPUNIT_ASSERT_DOUBLES_EQUAL(z, 0, epsilon);
-	CPPUNIT_ASSERT_DOUBLES_EQUAL(w, cos((45*deg2rad)/2), epsilon);
+	CPPUNIT_ASSERT_DOUBLES_EQUAL(w, ::cos((45*deg2rad)/2), epsilon);
     R2 = Rotation::Quaternion(x,y,z,w);
 	CPPUNIT_ASSERT_EQUAL(R,R2);    
 
     // direct 45 deg rotation in X
-    R2 = Rotation::Quaternion(sin((45*deg2rad)/2), 0, 0, cos((45*deg2rad)/2));
+    R2 = Rotation::Quaternion(::sin((45*deg2rad)/2), 0, 0, ::cos((45*deg2rad)/2));
 	CPPUNIT_ASSERT_EQUAL(R,R2);
     R2.GetQuaternion(x2,y2,z2,w2);
 	CPPUNIT_ASSERT_DOUBLES_EQUAL(x, x2, epsilon);
diff --git a/orocos_kdl/tests/kinfamtest.cpp b/orocos_kdl/tests/kinfamtest.cpp
index 2e28676..dc45625 100644
--- a/orocos_kdl/tests/kinfamtest.cpp
+++ b/orocos_kdl/tests/kinfamtest.cpp
@@ -7,6 +7,10 @@ CPPUNIT_TEST_SUITE_REGISTRATION( KinFamTest );
 
 #ifdef  __APPLE__
 typedef unsigned int uint;
+#else
+#ifndef  uint
+typedef unsigned int uint;
+#endif
 #endif
 
 using namespace KDL;
diff --git a/orocos_kdl/tests/solvertest.cpp b/orocos_kdl/tests/solvertest.cpp
index 7433d26..fe83353 100644
--- a/orocos_kdl/tests/solvertest.cpp
+++ b/orocos_kdl/tests/solvertest.cpp
@@ -4,6 +4,8 @@
 #include <kinfam_io.hpp>
 #include <time.h>
 
+#define _USE_MATH_DEFINES  // For MSVC
+#include <math.h>
 
 CPPUNIT_TEST_SUITE_REGISTRATION( SolverTest );
 
@@ -416,7 +418,7 @@ void SolverTest::VereshchaginTest()
     //desired is given by an interpolator
     //error is the difference between desired-actual
     //in this test only the actual values are printed.
-    int k = 1;
+    const int k = 1;
     JntArray jointPoses[k];
     JntArray jointRates[k];
     JntArray jointAccelerations[k];
-- 
1.8.0.msysgit.0

